/*
  Copyright (c) 2012, Matthias Schiffer <mschiffer@universe-factory.net>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


#ifndef _FFD_FFD_H_
#define _FFD_FFD_H_

#include "util.h"
#include "netif.h"

#include <net/if.h>


typedef struct _ffd_announce_t {
	struct _ffd_announce_t *next;

	uint8_t type;
	uint8_t len;
	uint8_t data[];
} ffd_announce_head_t;

typedef struct _ffd_neigh_t {
	struct _ffd_neigh_t *next;

	eth_addr_t addr;

	uint16_t hello_log;
	uint16_t hello_interval;
	uint16_t last_seqno;
	struct timespec last_hello;
	struct timespec last_ihu;

	uint16_t txcost;
} ffd_neigh_t;

typedef struct _ffd_iface_t {
	struct _ffd_iface_t *next;

	unsigned ifindex;
	char name[IF_NAMESIZE];
	eth_addr_t addr;

	netif_type_t type;
	uint16_t seqno;

	ffd_neigh_t *neigh_list;
} ffd_iface_t;

#endif /* _FFD_FFD_H_ */
